#!/usr/bin/perl

#
# Check to see if message is blocked by spamtrapd database. 
# 
# Takes one mail message on stdin
# Prints "yes" or "no"

#
# Load Configuration Variables

require '/usr/local/etc/spamtrapd.conf';  # Set ME!!

########## No user serviceable parts below #############

use MLDBM qw(DB_File Storable);
use Fcntl;

  use Sys::Syslog qw(:DEFAULT setlogsock);
  setlogsock("unix");
  openlog("blockcheck","","user");

$tt=&dbinit( $dbfile, \%table );
$nh=&counthosts(\%table);

$state="unknown";

while(<>){ #read spam from stdin

  if($state eq "unknown" and /^From\s+(.*?)\s+/){ #start of message 
                          #(If your messages don't start this way, you lose)
    $fromhead =  $1;
    $state="headers";
    undef %headers;
    undef $val;
    undef $header;
    $headers{"From_"} = $fromhead;
    next;

  }elsif($state eq "headers" and /^\s*$/){ #blank line ending headers
    last;

  }elsif($state eq "headers"){ #headers
    s/\s*$//;
    if(/^\s+/){
      s/^\s+//;
      $val .= " $_";
      next;
    }
    push(@{$headers{$header}}, $val) if ($header);
    ($header, $val)=split(/: /,$_,2);
  }

}

# Get relevant info from headers

#my $name;
#my $ip;
#my $score;
#my $val;

($xjr) =  @{ $headers{$receivedheader} };
($name, $ip) = ($xjr =~ /$rereceived/); 

($val)=@{$headers{$spamheader}};
if($val =~ /$rescore/){
  $score=$1;
} else {
  my $m=$headers{"Message-Id"}[0];
#  print STDERR "$m: Score not found\n";
  $score = 0;
}

#    syslog("notice","%s","Parsed: $xjr IP=$ip NAME=$name");

# Now we have ip; gotta decide what to do!

$tmp = $table{$ip};  # Look up IP in database

# Is it blocked in DB? 
if($tmp->{avg} > $spam_threshhold) {
  print "yes";
    syslog("notice","%s","found: $ip $name ($score/$tmp->{avg})");
} else {
  print "no";
}

# Might it have gotten through? 

if($tmp->{avg} > $spam_threshhold){

  if( $score < $spam_threshhold) {
    syslog("notice","%s","Lo Score: $ip $name ($score/$tmp->{avg})");
  }else{
    syslog("notice","%s","Hi Score: $ip $name ($score/$tmp->{avg})");
  }

}

exit;


sub dbinit {

  my $dbfile=shift;
  my $tableref=shift;

  (my $tt = tie %$tableref, 'MLDBM', $dbfile , O_RDONLY) 
                        or die "Can't tie to DB file $dbfile: $@";

  $tt->DumpMeth('portable');    # Ask for portable binary

  return $tt;

}

sub counthosts {

  my $tableref=shift;
  my $nh=0;

  eval { foreach (keys %$tableref) { $nh++; };  1; } or $nh=-1;
  return $nh;
}


