#! /usr/bin/perl

#
# Take spam on stdin and sends UDP notification to spamtrapd
#

$target_host = "yourhost.com";  # This is where spamtrapd runs
$target_port = 4321;              # and the port it listens on

$target_host2 = "anotherhost.com";

#$trustedmx="notused.com";        # Trusted MX who's "Received:" header
                                  # we will believe (can be a regexp, but must
                                  # only match ONE Received line!

$spamheader="X-AntiSPAM";    # Header that contains Spamassasin report
$rescore="SpamAssassin.+score=([-0-9.]+)";
                                  # Regexp that puts numeric spam score in $1

$virusheader="X-AntiVirus";    # Header that contains virus report
$virusword="infected";              # regexp that indicates a virus

# IP addresses we will whitelist

%whitehost=(
  "204.127.198.39" => 1,  # rwcrmhc13.comcast.net
  "204.127.198.35" => 1,  # rwcrmhc11.comcast.net
  "68.168.78.202" => 1,   # mta10.adelphia.net
  "24.92.226.49" => 1,    # ms-smtp-02.nyroc.rr.com
);

# Hostnames we will whitelist. These are regexps. 

@whitename=(
  "^mta.+",
  "^imr.+",
  "^smtp.+",
  "^ms-smtp.+",
  "crmhc.+comcast.net\$",
  "biz.mail.yahoo.com\$",
  "mx.aol.com\$",
  "mail.atl.earthlink.net\$",
  "scd.yahoo.com\$",
  "mail.pas.earthlink.net\$",
  "jtan.com\$",
);

# Spam score to give a virus

$virusscore=5;

# Extra for a harvested address

$harvestedscore=100;

# Increase scores by this factor to give extra penalty for being spamtrapped. 

$multiplier=2.0;

# Subtract this much from scores for mails that pass SPF checking
# SPF passes also ignore the multiplier

$spfbonus = 5;


################# Nothing to config with below here ####################

use IO::Socket::INET;

use Mail::SPF::Query;


$state="idle"; # email parsing state machine init

while(<>){ #read spam from stdin

  if(/^From\s+(.*?)\s+/){ #start of message (If your messages don't start this way, you lose)
$fromhead =  $1;
    $state="headers";
    undef %headers;
    undef $val;
    undef $header;
    $headers{"From_"} = $fromhead;
    next;
  }elsif($state eq "headers" and /^\s*$/){ #blank line ending headers
    $state="body";
    push(@{$headers{$header}}, $val) if ($header);

    my $f=shift @{$headers{From}};
    next if($f =~ /MAILER-DAEMON/);

    ($i,$s,$n)=&process_headers;

    my $match=0;
    foreach $wname (@whitename){
      if($n =~ /$wname/){      
        $match++;
        last;
      }
    }

    if ($i and not ($whitehost{$i} or $match)){
	quicknot($i,$s,$n);
    }else{
      my $m=$headers{"Message-Id"}[0];
 #     print STDERR "$m: IP not found\n";
    }
    next;
  }elsif($state eq "headers"){ #headers
    s/\s*$//;
    if(/^\s+/){
      s/^\s+//;
      $val .= " $_";
      next;
    }
    push(@{$headers{$header}}, $val) if ($header);
    ($header, $val)=split(/: /,$_,2);
  }

}

exit;

sub process_headers {

  my $ip;
  my $score;
  my $val;

# Received: from acd13.aaacdr.com ([216.82.109.113])      by
# ananke.jtan.com (8.12 .2/8.12.1) with ESMTP id h4NIGIsa024179        
# for <wweber@linex.com>; Fri, 23  May 2003 14:16:18 -0400 (EDT)
  
#  foreach $val ( @{ $headers{Received} }){
#    #next unless($val =~ /from [^[]+\[(\d+\.\d+\.\d+\.\d+)\].+by\s+$trustedmx/);
#    next unless($val =~ /from [^(]+\(([-A-Za-z0-9\.]*)[^[]+\[(\d+\.\d+\.\d+\.\d+)\].+by\s+(ananke|metis).jtan.com/);
#    $name = $1;
#    $ip=$2;
#  }

($xjr) =  @{ $headers{"X-JTAN-Received"} };

($name, $ip) = ($xjr =~ /\s*(\S*)\s*\[(\d+\.\d+\.\d+\.\d+)\]/);

  ($val)=@{$headers{$spamheader}};
  unless($val =~ /$rescore/){
     #print "\"$val\"";
     my $m=$headers{"Message-Id"}[0];
     #print STDERR "$m: Score not found\n";
    $score = 0;
  } else {
    $score=$1;
  }

eval {
  $spf = new Mail::SPF::Query ( ip => $ip, sender => $headers{"From_"}, helo => ($name or $ip));
  ($result) = $spf->result(); 
  if ($result eq "pass") {
    $score -= $spfbonus;
  } else {
    $score *= $multiplier;
  }
};

  $score+=$harvestedscore if($headers{To}=~/harvested\.[A-F0-9]+\@jtan.com/);

  ($val)=@{$headers{$virusheader}};
  if($val =~ /$virusword/) {
  	$score += $virusscore;
  }


#print "From: $headers{\"From_\"}\t Score: $score\n";



  return ($ip, $score,$name);

}

sub quicknot {
 my $ip = shift;
 my $score = shift;
 my $name = shift;

my $mysocket = new IO::Socket::INET->new(PeerPort=>$target_port,Proto=>'udp',PeerAddr=>$target_host);
$mysocket->send("\"$ip\"-\"$score\"-\"$name\"");

my $mysocket = new IO::Socket::INET->new(PeerPort=>$target_port,Proto=>'udp',PeerAddr=>$target_host2);
$mysocket->send("\"$ip\"-\"$score\"-\"$name\"");
}

